/*---------------------------------------------------------------------------
 * @file     | Unit1.cpp
 * ----------+---------------------------------------------------------------
 * @function | ITE EC Utility Sample Code
 * ----------+---------------------------------------------------------------
 * @model    | ITE Windows console Application Source Code
 * @version  | N/A
 * @author   | ---
 * @note     | C++Builder 6.0 Sample code
 *-------------------------------------------------------------------------*/
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include <time.h>
#include <fstream.h>
//---------------------------------------------------------------------------
#include "Unit1.h"
//---------------------------------------------------------------------------
// DLL I/O DRIVER
//---------------------------------------------------------------------------
typedef void    (__stdcall *lpOut32)(short, short);
typedef short   (__stdcall *lpInp32)(short);
typedef BOOL    (__stdcall *lpIsInpOutDriverOpen)(void);
typedef BOOL    (__stdcall *lpIsXP64Bit)(void);
//---------------------------------------------------------------------------
// Global function pointers & Variables & Resources
//---------------------------------------------------------------------------
bool    Win64Bit = false, DRIVER_OK = false;
lpOut32 gfpOut32;
lpInp32 gfpInp32;
lpIsInpOutDriverOpen gfpIsInpOutDriverOpen;
lpIsXP64Bit gfpIsXP64Bit;
HINSTANCE hInpOutDll;
//---------------------------------------------------------------------------
FILE    *pFile;
char    TempBuf[128];
#define _INDEX_EIO_CHIP_STS       0x10
#define _INDEX_EIO_CHIP1_IN       0x11
#define _INDEX_EIO_CHIP1_OUT      0x12
#define _INDEX_EIO_CHIP2_IN       0x13
#define _INDEX_EIO_CHIP2_OUT      0x14
#define _INDEX_EIO_CHIP3_IN       0x15
#define _INDEX_EIO_CHIP3_OUT      0x16
#define _INDEX_EIO_CHIP4_IN       0x17
#define _INDEX_EIO_CHIP4_OUT      0x18
#define _IO_CHIP1       0x01
#define _IO_CHIP2       0x02
#define _IO_CHIP3       0x03
#define _IO_CHIP4       0x04
#define _PIN1           0x01
#define _PIN2           0x02
#define _PIN3           0x03
#define _PIN4           0x04
#define _OUT_HI         1
#define _OUT_LO         0
#define _BIT0           0x01
#define _BIT1           0x02
#define _BIT2           0x04
#define _BIT3           0x08
#define _BIT4           0x10
#define _BIT5           0x20
#define _BIT6           0x40
#define _BIT7           0x80

//---------------------------------------------------------------------------
int     gExGpioChipSts;
int     gExGpioChip1In, gExGpioChip2In, gExGpioChip3In, gExGpioChip4In;
int     gExGpioChip1Out = 0x00;
int     gExGpioChip2Out = 0x00;
int     gExGpioChip3Out = 0x00;
int     gExGpioChip4Out = 0x00;

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
#if 1   /* DRIVER */
        //-------------------------------------------------------------------
        printf("Load io.dll ...... ");
        hInpOutDll = LoadLibrary("io.dll");
        if (hInpOutDll == NULL)
        {
                printf("Please check io.dll driver file exist !\n");
                exit(0);
        }
        gfpOut32 = (lpOut32)GetProcAddress(hInpOutDll, "Out32");
        gfpInp32 = (lpInp32)GetProcAddress(hInpOutDll, "Inp32");
        gfpIsInpOutDriverOpen =
                (lpIsInpOutDriverOpen)
                GetProcAddress(hInpOutDll, "IsInpOutDriverOpen");
        gfpIsXP64Bit = (lpIsXP64Bit)
                GetProcAddress(hInpOutDll, "IsXP64Bit");
        if (gfpIsInpOutDriverOpen())
        {
                DRIVER_OK = true;
        }
        else
        {
                printf("Please Run Administrator Once !\n");
                exit(0);
        }
#endif
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
        gfpOut32(0x6A, _INDEX_EIO_CHIP_STS);
        gExGpioChipSts = gfpInp32(0x6B);
        if ((gExGpioChipSts & 0xF0) != 0xE0)
        {
                Form1->RichEdit1->Lines->Add("EC FW Not Support Expander IO");
        }
        else
        {
                if (gExGpioChipSts & 0x01)
                {
                        Form1->RichEdit1->Lines->Add("CHIP-1 Installed");
                }
                else
                {
                        Form1->RichEdit1->Lines->Add("CHIP-1 Not Found");
                }
                if (gExGpioChipSts & 0x02)
                {
                        Form1->RichEdit1->Lines->Add("CHIP-2 Installed");
                }
                else
                {
                        Form1->RichEdit1->Lines->Add("CHIP-2 Not Found");
                }
                if (gExGpioChipSts & 0x04)
                {
                        Form1->RichEdit1->Lines->Add("CHIP-3 Installed");
                }
                else
                {
                        Form1->RichEdit1->Lines->Add("CHIP-3 Not Found");
                }
                if (gExGpioChipSts & 0x08)
                {
                        Form1->RichEdit1->Lines->Add("CHIP-4 Installed");
                }
                else
                {
                        Form1->RichEdit1->Lines->Add("CHIP-4 Not Found");
                }                
        }
        RichEdit1->Perform(WM_VSCROLL, SB_BOTTOM, 0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn2Click(TObject *Sender)
{
        if ((gExGpioChipSts & 0x01) == 0)
        {
                return;
        }
        gfpOut32(0x6A, _INDEX_EIO_CHIP1_IN);
        gExGpioChip1In = gfpInp32(0x6B);
        if (gExGpioChip1In & 0x01)
        {
                Form1->RichEdit1->Lines->Add("CHIP-1 INPUT-1 HI");
        }
        else
        {
                Form1->RichEdit1->Lines->Add("CHIP-1 INPUT-1 LO");
        }
        if (gExGpioChip1In & 0x02)
        {
                Form1->RichEdit1->Lines->Add("CHIP-1 INPUT-2 HI");
        }
        else
        {
                Form1->RichEdit1->Lines->Add("CHIP-1 INPUT-2 LO");
        }
        if (gExGpioChip1In & 0x04)
        {
                Form1->RichEdit1->Lines->Add("CHIP-1 INPUT-3 HI");
        }
        else
        {
                Form1->RichEdit1->Lines->Add("CHIP-1 INPUT-3 LO");
        }
        if (gExGpioChip1In & 0x08)
        {
                Form1->RichEdit1->Lines->Add("CHIP-1 INPUT-4 HI");
        }
        else
        {
                Form1->RichEdit1->Lines->Add("CHIP-1 INPUT-4 LO");
        }
        RichEdit1->Perform(WM_VSCROLL, SB_BOTTOM, 0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn3Click(TObject *Sender)
{
        if ((gExGpioChipSts & 0x02) == 0)
        {
                return;
        }
        gfpOut32(0x6A, _INDEX_EIO_CHIP2_IN);
        gExGpioChip2In = gfpInp32(0x6B);
        if (gExGpioChip2In & 0x01)
        {
                Form1->RichEdit1->Lines->Add("CHIP-2 INPUT-1 HI");
        }
        else
        {
                Form1->RichEdit1->Lines->Add("CHIP-2 INPUT-1 LO");
        }
        if (gExGpioChip2In & 0x02)
        {
                Form1->RichEdit1->Lines->Add("CHIP-2 INPUT-2 HI");
        }
        else
        {
                Form1->RichEdit1->Lines->Add("CHIP-2 INPUT-2 LO");
        }
        if (gExGpioChip2In & 0x04)
        {
                Form1->RichEdit1->Lines->Add("CHIP-2 INPUT-3 HI");
        }
        else
        {
                Form1->RichEdit1->Lines->Add("CHIP-2 INPUT-3 LO");
        }
        if (gExGpioChip2In & 0x08)
        {
                Form1->RichEdit1->Lines->Add("CHIP-2 INPUT-4 HI");
        }
        else
        {
                Form1->RichEdit1->Lines->Add("CHIP-2 INPUT-4 LO");
        }
        RichEdit1->Perform(WM_VSCROLL, SB_BOTTOM, 0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn4Click(TObject *Sender)
{
        if ((gExGpioChipSts & 0x04) == 0)
        {
                return;
        }
        gfpOut32(0x6A, _INDEX_EIO_CHIP3_IN);
        gExGpioChip3In = gfpInp32(0x6B);
        if (gExGpioChip3In & 0x01)
        {
                Form1->RichEdit1->Lines->Add("CHIP-3 INPUT-1 HI");
        }
        else
        {
                Form1->RichEdit1->Lines->Add("CHIP-3 INPUT-1 LO");
        }
        if (gExGpioChip3In & 0x02)
        {
                Form1->RichEdit1->Lines->Add("CHIP-3 INPUT-2 HI");
        }
        else
        {
                Form1->RichEdit1->Lines->Add("CHIP-3 INPUT-2 LO");
        }
        if (gExGpioChip3In & 0x04)
        {
                Form1->RichEdit1->Lines->Add("CHIP-3 INPUT-3 HI");
        }
        else
        {
                Form1->RichEdit1->Lines->Add("CHIP-3 INPUT-3 LO");
        }
        if (gExGpioChip3In & 0x08)
        {
                Form1->RichEdit1->Lines->Add("CHIP-3 INPUT-4 HI");
        }
        else
        {
                Form1->RichEdit1->Lines->Add("CHIP-3 INPUT-4 LO");
        }
        RichEdit1->Perform(WM_VSCROLL, SB_BOTTOM, 0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn5Click(TObject *Sender)
{
        if ((gExGpioChipSts & 0x08) == 0)
        {
                return;
        }
        gfpOut32(0x6A, _INDEX_EIO_CHIP4_IN);
        gExGpioChip4In = gfpInp32(0x6B);
        if (gExGpioChip4In & 0x01)
        {
                Form1->RichEdit1->Lines->Add("CHIP-4 INPUT-1 HI");
        }
        else
        {
                Form1->RichEdit1->Lines->Add("CHIP-4 INPUT-1 LO");
        }
        if (gExGpioChip4In & 0x02)
        {
                Form1->RichEdit1->Lines->Add("CHIP-4 INPUT-2 HI");
        }
        else
        {
                Form1->RichEdit1->Lines->Add("CHIP-4 INPUT-2 LO");
        }
        if (gExGpioChip4In & 0x04)
        {
                Form1->RichEdit1->Lines->Add("CHIP-4 INPUT-3 HI");
        }
        else
        {
                Form1->RichEdit1->Lines->Add("CHIP-4 INPUT-3 LO");
        }
        if (gExGpioChip4In & 0x08)
        {
                Form1->RichEdit1->Lines->Add("CHIP-4 INPUT-4 HI");
        }
        else
        {
                Form1->RichEdit1->Lines->Add("CHIP-4 INPUT-4 LO");
        }
        RichEdit1->Perform(WM_VSCROLL, SB_BOTTOM, 0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ExtPinOutput(int ChipNum, int PinNum, int PinOut)
{
        int     Values_AND, Values_OR;

#if 1 
        strcpy(TempBuf, "CHIP-[ ]-PIN-[ ]-SET[ ]");
        TempBuf[6] = 0x30+ChipNum;
        TempBuf[14] = 0x30+PinNum;
        TempBuf[21] = 'H';
        if (PinOut == 0)        TempBuf[21] = 'L';
        Form1->RichEdit1->Lines->Add(TempBuf);
        RichEdit1->Perform(WM_VSCROLL, SB_BOTTOM, 0);
#endif
        
        Values_AND = 0xFF;
        Values_OR = 0x00;
        /* Pin1 = BIT4, Pin2 = BIT5, Pin3 = BIT6, Pin4 = BIT7 */
        if (PinNum == 1)
        {
          if (PinOut == 0)
          {
                Values_AND = ~_BIT4;
          }
          else
          {
                Values_OR = _BIT4;
          }
        }
        else if (PinNum == 2)
        {
          if (PinOut == 0)
          {
                Values_AND = ~_BIT5;
          }
          else
          {
                Values_OR = _BIT5;
          }
        }
        else if (PinNum == 3)
        {
          if (PinOut == 0)
          {
                Values_AND = ~_BIT6;
          }
          else
          {
                Values_OR = _BIT6;
          }
        }
        else if (PinNum == 4)
        {
          if (PinOut == 0)
          {
                Values_AND = ~_BIT7;
          }
          else
          {
                Values_OR = _BIT7;
          }
        }

        if (ChipNum == _IO_CHIP1)
        {
                gfpOut32(0x6A, _INDEX_EIO_CHIP1_OUT);
                gExGpioChip1Out = gfpInp32(0x6B);       /* Read Back */
                gExGpioChip1Out &= Values_AND;
                gExGpioChip1Out |= Values_OR;                
                gfpOut32(0x6B, gExGpioChip1Out);
        }
        if (ChipNum == _IO_CHIP2)
        {
                gfpOut32(0x6A, _INDEX_EIO_CHIP2_OUT);
                gExGpioChip2Out = gfpInp32(0x6B);       /* Read Back */
                gExGpioChip2Out &= Values_AND;
                gExGpioChip2Out |= Values_OR;
                gfpOut32(0x6B, gExGpioChip2Out);
        }
        if (ChipNum == _IO_CHIP3)
        {

                gfpOut32(0x6A, _INDEX_EIO_CHIP3_OUT);
                gExGpioChip3Out = gfpInp32(0x6B);       /* Read Back */
                gExGpioChip3Out &= Values_AND;
                gExGpioChip3Out |= Values_OR;
                gfpOut32(0x6B, gExGpioChip3Out);
        }
        if (ChipNum == _IO_CHIP4)
        {
                gfpOut32(0x6A, _INDEX_EIO_CHIP4_OUT);
                gExGpioChip4Out = gfpInp32(0x6B);       /* Read Back */
                gExGpioChip4Out &= Values_AND;
                gExGpioChip4Out |= Values_OR;
                gfpOut32(0x6B, gExGpioChip4Out);
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP1, _PIN1, _OUT_HI);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton3Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP1, _PIN2, _OUT_HI);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton5Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP1, _PIN3, _OUT_HI);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton6Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP1, _PIN4, _OUT_HI);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP1, _PIN1, _OUT_LO);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton4Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP1, _PIN2, _OUT_LO);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton7Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP1, _PIN3, _OUT_LO);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton8Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP1, _PIN4, _OUT_LO);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton9Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP2, _PIN1, _OUT_HI);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton11Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP2, _PIN2, _OUT_HI);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton13Click(TObject *Sender)
{
         ExtPinOutput(_IO_CHIP2, _PIN3, _OUT_HI);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton14Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP2, _PIN4, _OUT_HI);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton10Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP2, _PIN1, _OUT_LO);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton12Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP2, _PIN2, _OUT_LO);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton15Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP2, _PIN3, _OUT_LO);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton16Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP2, _PIN4, _OUT_LO);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton17Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP3, _PIN1, _OUT_HI);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton19Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP3, _PIN2, _OUT_HI);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton21Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP3, _PIN3, _OUT_HI);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton22Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP3, _PIN4, _OUT_HI);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton18Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP3, _PIN1, _OUT_LO);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton20Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP3, _PIN2, _OUT_LO);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton23Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP3, _PIN3, _OUT_LO);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton24Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP3, _PIN4, _OUT_LO);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton25Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP4, _PIN1, _OUT_HI);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton27Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP4, _PIN2, _OUT_HI);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton29Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP4, _PIN3, _OUT_HI);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton30Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP4, _PIN4, _OUT_HI);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton26Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP4, _PIN1, _OUT_LO);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton28Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP4, _PIN2, _OUT_LO);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton31Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP4, _PIN3, _OUT_LO);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton32Click(TObject *Sender)
{
        ExtPinOutput(_IO_CHIP4, _PIN4, _OUT_LO);
}
//---------------------------------------------------------------------------

